# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Union
from . import utilities, tables

class GetAclRoleResult:
    """
    A collection of values returned by getAclRole.
    """
    def __init__(__self__, description=None, id=None, name=None, namespace=None, policies=None, service_identities=None):
        if description and not isinstance(description, str):
            raise TypeError("Expected argument 'description' to be a str")
        __self__.description = description
        """
        The description of the ACL Role.
        """
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        __self__.id = id
        """
        The provider-assigned unique ID for this managed resource.
        """
        if name and not isinstance(name, str):
            raise TypeError("Expected argument 'name' to be a str")
        __self__.name = name
        if namespace and not isinstance(namespace, str):
            raise TypeError("Expected argument 'namespace' to be a str")
        __self__.namespace = namespace
        if policies and not isinstance(policies, list):
            raise TypeError("Expected argument 'policies' to be a list")
        __self__.policies = policies
        """
        The list of policies associated with the ACL Role. Each entry has
        an `id` and a `name` attribute.
        """
        if service_identities and not isinstance(service_identities, list):
            raise TypeError("Expected argument 'service_identities' to be a list")
        __self__.service_identities = service_identities
        """
        The list of service identities associated with the ACL
        Role. Each entry has a `service_name` attribute and a list of `datacenters`.
        """
class AwaitableGetAclRoleResult(GetAclRoleResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetAclRoleResult(
            description=self.description,
            id=self.id,
            name=self.name,
            namespace=self.namespace,
            policies=self.policies,
            service_identities=self.service_identities)

def get_acl_role(description=None,name=None,namespace=None,policies=None,service_identities=None,opts=None):
    """
    The `AclRole` data source returns the information related to a
    [Consul ACL Role](https://www.consul.io/api/acl/roles.html).

    ## Example Usage

    ```python
    import pulumi
    import pulumi_consul as consul

    test = consul.get_acl_role(name="example-role")
    pulumi.export("consulAclRole", test.id)
    ```


    :param str description: The description of the ACL Role.
    :param str name: The name of the ACL Role.
    :param str namespace: The namespace to lookup the role.
    :param list policies: The list of policies associated with the ACL Role. Each entry has
           an `id` and a `name` attribute.
    :param list service_identities: The list of service identities associated with the ACL
           Role. Each entry has a `service_name` attribute and a list of `datacenters`.

    The **policies** object supports the following:

      * `id` (`str`)
      * `name` (`str`) - The name of the ACL Role.

    The **service_identities** object supports the following:

      * `datacenters` (`list`)
      * `serviceName` (`str`)
    """
    __args__ = dict()


    __args__['description'] = description
    __args__['name'] = name
    __args__['namespace'] = namespace
    __args__['policies'] = policies
    __args__['serviceIdentities'] = service_identities
    if opts is None:
        opts = pulumi.InvokeOptions()
    if opts.version is None:
        opts.version = utilities.get_version()
    __ret__ = pulumi.runtime.invoke('consul:index/getAclRole:getAclRole', __args__, opts=opts).value

    return AwaitableGetAclRoleResult(
        description=__ret__.get('description'),
        id=__ret__.get('id'),
        name=__ret__.get('name'),
        namespace=__ret__.get('namespace'),
        policies=__ret__.get('policies'),
        service_identities=__ret__.get('serviceIdentities'))
